      STRUCTURE  /SLIT/
	  CHARACTER*32  NAME
	  REAL*8 AXI,AXV,DIST
	  REAL*8 SIZE(3),STA(3),GON(3)
	  REAL*8 POS(3),ROT(3,3),ROT1(3,3)
	  LOGICAL*4 MAP(3),MAP1(3)
	  INTEGER*4 COUNT  
	  INTEGER*4  SHAPE
      END STRUCTURE     ! size = 320
C
      STRUCTURE  /DETECTOR/
	  RECORD /SLIT/ FRAME
	  REAL*8 ALPHA ! efficiency coeff. [1/A/cm]
	  REAL*8 SPACE ! distance between adjacent tubes
	  INTEGER*4 ND ! number of tubes in an array  
      END STRUCTURE     ! size = 340
C

      STRUCTURE  /NEUTRON/
          REAL*8 R(3),K(3),T,S,P
      END STRUCTURE   

C BENDER:
C TYP < 0	.. ignore
C TYP = 0	.. normal course or soller collimator
C TYP = 1	.. guide or bender (reflecting walls)
C TYP = 2	.. parabolic guide
C TYP = 3	.. parabolic guide with optimum lamella lengths

      STRUCTURE  /BENDER/
	   RECORD /SLIT/ FRAME
           REAL*8 W2,H2           ! width & height at the exit
           REAL*8 GHLU,GHLD,GHRU,GHRD,GVT,GVB  ! horizontal & vertical (H&V) critical angles
           REAL*8 RHLU,RHLD,RHRU,RHRD,RVT,RVB  ! horizontal& vertical reflectivities
           REAL*8 DLH,DLV         ! thickness of H&V lamellae
           REAL*8 CH,CV           ! curvatures            
           REAL*4 AH(0:127),AV(0:127) ! parameters of lamellae (for parabolic profile)           
           REAL*4 LH(0:127),LV(0:127) ! lengths of lamellae (for parabolic profile)           
           INTEGER*4 NLH,NLV      ! number of slits (H&V), max.=127
           INTEGER*4 TYP          ! 0.. normal, 1 .. curved, 2 .. reflecting surfaces 
           INTEGER*4 NHLU,NHLD,NHRU,NHRD,NVT,NVB ! indexes pointing to the fieald containg reflectivity data
           INTEGER*4 OSCILATE
      END STRUCTURE             ! size = 2552  ( before 496)  
      
      STRUCTURE /CRYSTAL/
           RECORD /SLIT/ FRAME
           REAL*8 DHKL,CHI,POI,HMOS,VMOS,QML,VOL,MI,DW,MAG
           REAL*8 RH,RV,RB,DH,DV,DB
           REAL*8 sigmab, sigmaa, A, thetaD, C2
           REAL*8 DLam,Dext,Ext1,DELTA
           REAL*8 THB,LAMBDA,STMCH,CTMCH,QHKL,REF,DETA,TANVOL
           REAL*8 DG_DR(3,3),G(3),GAMA(3),GTOT,DGR,DGA
           LOGICAL*4 MAPG(3)
           INTEGER*4 DNRND
           INTEGER*4 nh,nv,nb,nref   
      END STRUCTURE             ! size = 760 
       
      STRUCTURE /SETUP/
         INTEGER*4 NFX,SM,SS,SA
         REAL*8 KFIX,E,Q,KI,KF,EI0,EF0
      END STRUCTURE       
           
      STRUCTURE  /SOLLER/
	 RECORD /SLIT/ FRAME
           REAL*8 W2,H2
           INTEGER*4 NL
           INTEGER*4 VERTICAL
      END STRUCTURE
      
